[![Tests](https://img.shields.io/github/actions/workflow/status/gcuder/SoftAdaptX/test.yml?branch=main)](https://github.com/gcuder/SoftAdaptX/actions/workflows/test.yml)

# SoftAdaptX

This repository contains an updated implementation of the [SoftAdapt algorithm](https://arxiv.org/pdf/1912.12355.pdf)(
techniques for adaptive loss balancing of multi-tasking neural networks).
This work continues on the awesome work of [Ali Heydari](https://github.com/dr-aheydari) (
see https://github.com/dr-aheydari/SoftAdapt) and aims to have a more streamlined and versatile implementation of
SoftAdapt.

[![arXiv:10.48550/arXiv.1912.12355](http://img.shields.io/badge/arXiv-110.48550/arXiv.2206.04047-A42C25.svg)](
https://doi.org/10.48550/arXiv.1912.12355)

## Installation

### Using pip

SoftAdaptX is officially released on PyPI. To install SoftAdaptX with pip:

```bash
pip install softadaptx
```

### Local installation

SoftAdapt now uses [Poetry](https://python-poetry.org/) for dependency management. To install SoftAdapt with Poetry:

1. First, make sure you have Poetry installed:

```bash
curl -sSL https://install.python-poetry.org | python3 -
```

2. Then, you can install SoftAdapt directly from GitHub:

```bash
poetry add git+https://github.com/dr-aheydari/SoftAdapt.git
```

3. Or clone the repository and install locally:

```bash
git clone https://github.com/dr-aheydari/SoftAdapt.git
cd SoftAdapt
poetry install
```

## Contributing

Contributions are welcome. Please follow these steps to contribute:

1. Fork the repository on GitHub.
2. Create a new branch for your feature or bug fix.
3. Make your changes and commit them.
4. Push your changes to your fork.
5. Submit a pull request to the main branch of the original repository.
